class Kutu{
	int genis;
	int yuksek;
	int derin;
	//p.siz yapc
	Kutu(){
		genis = yuksek = derin =-1;
	}
	//Kup 
	Kutu(int uzun) {
		genis = yuksek = derin = uzun;
	}
	Kutu(int genis, int yuksek, int derin){
		this.genis = genis;
		this.yuksek = yuksek;
		this.derin = derin;
	}
	Kutu(Kutu nes){
		genis = nes.genis;
		yuksek = nes.yuksek;
		derin = nes.derin;
	}
	int hacim(){
		return genis * yuksek * derin;
	}
}
class KutuAgirlik extends Kutu {
	int agir;
	
	KutuAgirlik(int genis, int yuksek, int derin, int agir){
		/*this.genis = genis;
		this.yuksek = yuksek;
		this.derin = derin;
		*/
		super(genis,yuksek,derin);
		this.agir = agir;
	}
	
	KutuAgirlik() {
		super();
		agir = -1;
	}
	
	KutuAgirlik(KutuAgirlik nes){
		super(nes);
		agir = nes.agir;
	}
}

class KutuRenk extends Kutu {
	int renk;
	
	KutuRenk(int genis, int yuksek, int derin, int renk){
	/*	this.genis = genis;
		this.yuksek = yuksek;
		this.derin = derin;
		*/
		super(genis,yuksek,derin);
		this.renk = renk;
	}
}

public class DemoKutuAgirlik {

	public static void main(String[] args) {
	/*	KutuAgirlik nesne = new KutuAgirlik(1,2,3,4);
		Kutu nesne1 = new Kutu();
		
		nesne1 = nesne;
		
		double hacim = nesne1.hacim();
		//System.out.println(nesne1.agir);
	*/
	
	//Soyut snfa ait bir nesne oluturulamaz.
	//Sekil s = new Sekil(10,10);
	Dikdortgen d = new Dikdortgen(10,10);
	Ucgen u = new Ucgen(10,10);
	Sekil ref;
	
	//ref = s;
	//System.out.println(ref.alan());
	
	ref = d;
	System.out.println(ref.alan());
	
	ref = u;
	System.out.println(ref.alan());
	}

}


class A{
	int x;
	A(){
		System.out.println("A");
	}
	void yaz(){
		System.out.println(x);
	}
}
class B extends A{
	int x;
	B(){
		System.out.println("B");
	}
	void yaz(){
		super.yaz();
		System.out.println(super.x);
	}
}

abstract class Sekil{
	double genis;
	double yuksek;
	Sekil(double g, double y){
		genis = g;
		yuksek = y;
	}
	abstract double alan();//{
//		System.out.println("ekil tanmlanmad");
//		return 0;
//	}
}

class Dikdortgen extends Sekil{
	Dikdortgen(double g, double y){
		super(g,y);
	}
	
	double alan(){
		return genis*yuksek;
	}
}

class Ucgen extends Sekil{
	Ucgen(double g, double y){
		super(g,y);
	}
	
	double alan(){
		return 0.5*genis*yuksek;
	}
}

class AA{
	final void f(){
		
	}
}

class BB extends AA{
	@Override
	void f(){
		
	}
}